﻿/*
    Universität Hamburg
	Fakultät für Mathematik, Informatik und Naturwissenschaften
	Fachbereich Informatik
	Arbeitsbereich Wissenschaftliches Rechen
	Seminar "Effiziente Programmierung in C"
	Thema "CPU-Caches"
	Beispiel "Alignment"
    Copyright (C) 2014  Christian Dusse

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/**
 * Die Größe des zu testenden Arrays
 */
#define AMOUNT 1000*1000*100

typedef struct data data;

/**
 * Die zu optimierende Struktur
 */
struct data
{
#ifndef OPTIMIZED
    char a;
    int b;
    char c;
#else
    int b;
    char a;
    char c;
#endif
};

/**
 * Die zu messende Funktion
 */
void foo(data myData[AMOUNT])
{
    for (long i = 0; i < AMOUNT; i++)
    {
        myData[i].a++;
    }
}

int main(int argc, char *argv[])
{
    // Alloziieren des Speichers für das Array
    data * myData = malloc(AMOUNT * sizeof(data));
    if (myData == NULL)
    {
        // Bei Scheitern zumindest eine kurze Fehlermeldung
        printf("%s", "error");
    }

    // Start der Zeitmessung
    double tstart = (double) clock() / CLOCKS_PER_SEC;

    // Aufruf der zu messenden Funktion
    foo(myData);

    // Ende der Zeitmessung
    double tstop = (double) clock() / CLOCKS_PER_SEC;

    // Freigeben des Speichers und Zurücksetzen des Pointers
    free(myData);
    myData = NULL;

    // Ausgabe der Zeitmessung
    printf("%f", tstop - tstart);

    return 0;
}
