﻿/*
    Universität Hamburg
	Fakultät für Mathematik, Informatik und Naturwissenschaften
	Fachbereich Informatik
	Arbeitsbereich Wissenschaftliches Rechen
	Seminar "Effiziente Programmierung in C"
	Thema "CPU-Caches"
	Beispiel "Datenlokalität"
    Copyright (C) 2014  Christian Dusse

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/**
 * Die Anzahl der Zeilen des Arrays
 */
#define ROW_SIZE 1000*10

/**
 * Die Anzahl der Spalten des Arrays
 */
#define AMOUNT_ROWS 1000*10

/**
 * Die zu messende Funktion
 */
void foo(char p[ROW_SIZE*AMOUNT_ROWS])
{
#ifndef OPTIMIZED
    // Spaltenweiser Aufruf
    for (long x=0; x<ROW_SIZE; x++)
    {
        for (long y=0; y<AMOUNT_ROWS; y++)
        {
#else
    // Zeilenweiser Aufruf
    for (long y = 0; y < AMOUNT_ROWS; y++)
    {
        for (long x = 0; x < ROW_SIZE; x++)
        {
#endif
            {
                p[x + y * ROW_SIZE]++;
            }
        }
    }
}

int main(int argc, char *argv[])
{
    // Alloziieren des Speichers für das Array
    char * p = malloc(ROW_SIZE * AMOUNT_ROWS * sizeof(char));
    if (p == NULL)
    {
	    // Bei Scheitern zumindest eine kurze Fehlermeldung
        printf("%s", "error");
    }

	// Start der Zeitmessung
    double tstart = (double) clock() / CLOCKS_PER_SEC;

	// Aufruf der zu messenden Funktion
    foo(p);
	
	// Ende der Zeitmessung
	double tstop = (double) clock() / CLOCKS_PER_SEC;

	// Freigeben des Speichers und Zurücksetzen des Pointers
    free(p);
    p = NULL;

	// Ausgabe der Zeitmessung
    printf("%f", tstop - tstart);
	
    return 0;
}
